*environment noecho


********************************************************************
compute [label] name = 'rra1'     ;* filename
compute [label] type1 = 'l'      ;* levels ('l') or diff ('d')
compute [label] type2 = 'a'      ;* all ('a') or one constant ('c')
compute [label] type3 = 'f'      ;* first shocked ('f') or second ('s')
*********************************************************************

cal 60 1 4
all 30 97:4


compute lags=4; compute nvar=3; compute nstep=20; compute ndraws=500
dec vector[series] resids(nvar)
*  defines the order of the variables in the VAR
eqv 1 to nvar; tax gcn  gdp


open data us.rat; data(format=rats,missing=-999) /

compute [label] prel = 'pr'+type1+'1.src'; source &prel
compute [label] dummies = 'dum'+type1+'1.src'; source &dummies


* quadratic trend

linreg tax
# tax{1 to 4} gcn{1 to 4} gdp{1 to 4}  $
  q2tax1 q2tax2 q2tax3 q2tax4  q2gcn1 q2gcn2 q2gcn3 q2gcn4 q2gdp1 q2gdp2 q2gdp3 q2gdp4   $
  q3tax1 q3tax2 q3tax3 q3tax4  q3gcn1 q3gcn2 q3gcn3 q3gcn4 q3gdp1 q3gdp2 q3gdp3 q3gdp4   $
  q4tax1 q4tax2 q4tax3 q4tax4  q4gcn1 q4gcn2 q4gcn3 q4gcn4 q4gdp1 q4gdp2 q4gdp3 q4gdp4   $
  vec1

exclude(noprint)
# q2tax1 q2tax2 q2tax3 q2tax4  q2gcn1 q2gcn2 q2gcn3 q2gcn4 q2gdp1 q2gdp2 q2gdp3 q2gdp4   $
  q3tax1 q3tax2 q3tax3 q3tax4  q3gcn1 q3gcn2 q3gcn3 q3gcn4 q3gdp1 q3gdp2 q3gdp3 q3gdp4   $
  q4tax1 q4tax2 q4tax3 q4tax4  q4gcn1 q4gcn2 q4gcn3 q4gcn4 q4gdp1 q4gdp2 q4gdp3 q4gdp4
display ' '
display 'p-value for quarter-dependent coefficients' #.### %signif
display ' '

linreg gcn
# tax{1 to 4} gcn{1 to 4} gdp{1 to 4}  $
  q2tax1 q2tax2 q2tax3 q2tax4  q2gcn1 q2gcn2 q2gcn3 q2gcn4 q2gdp1 q2gdp2 q2gdp3 q2gdp4   $
  q3tax1 q3tax2 q3tax3 q3tax4  q3gcn1 q3gcn2 q3gcn3 q3gcn4 q3gdp1 q3gdp2 q3gdp3 q3gdp4   $
  q4tax1 q4tax2 q4tax3 q4tax4  q4gcn1 q4gcn2 q4gcn3 q4gcn4 q4gdp1 q4gdp2 q4gdp3 q4gdp4   $
  vec1

exclude(noprint)
# q2tax1 q2tax2 q2tax3 q2tax4  q2gcn1 q2gcn2 q2gcn3 q2gcn4 q2gdp1 q2gdp2 q2gdp3 q2gdp4   $
  q3tax1 q3tax2 q3tax3 q3tax4  q3gcn1 q3gcn2 q3gcn3 q3gcn4 q3gdp1 q3gdp2 q3gdp3 q3gdp4   $
  q4tax1 q4tax2 q4tax3 q4tax4  q4gcn1 q4gcn2 q4gcn3 q4gcn4 q4gdp1 q4gdp2 q4gdp3 q4gdp4

display ' '
display 'p-value for quarter-dependent coefficients' #.### %signif
display ' '


linreg gdp
# tax{1 to 4} gcn{1 to 4} gdp{1 to 4}  $
  q2tax1 q2tax2 q2tax3 q2tax4  q2gcn1 q2gcn2 q2gcn3 q2gcn4 q2gdp1 q2gdp2 q2gdp3 q2gdp4   $
  q3tax1 q3tax2 q3tax3 q3tax4  q3gcn1 q3gcn2 q3gcn3 q3gcn4 q3gdp1 q3gdp2 q3gdp3 q3gdp4   $
  q4tax1 q4tax2 q4tax3 q4tax4  q4gcn1 q4gcn2 q4gcn3 q4gcn4 q4gdp1 q4gdp2 q4gdp3 q4gdp4   $
  vec1

exclude(noprint)
# q2tax1 q2tax2 q2tax3 q2tax4  q2gcn1 q2gcn2 q2gcn3 q2gcn4 q2gdp1 q2gdp2 q2gdp3 q2gdp4   $
  q3tax1 q3tax2 q3tax3 q3tax4  q3gcn1 q3gcn2 q3gcn3 q3gcn4 q3gdp1 q3gdp2 q3gdp3 q3gdp4   $
  q4tax1 q4tax2 q4tax3 q4tax4  q4gcn1 q4gcn2 q4gcn3 q4gcn4 q4gdp1 q4gdp2 q4gdp3 q4gdp4

display ' '
display 'p-value for quarter-dependent coefficients' #.### %signif
display ' '



system 1 to nvar; variables  1 to nvar; lags 1 to lags; kfset xxx;
det vec1 $
  q2tax1 q2tax2 q2tax3 q2tax4  q2gcn1 q2gcn2 q2gcn3 q2gcn4 q2gdp1 q2gdp2 q2gdp3 q2gdp4   $
  q3tax1 q3tax2 q3tax3 q3tax4  q3gcn1 q3gcn2 q3gcn3 q3gcn4 q3gdp1 q3gdp2 q3gdp3 q3gdp4   $
  q4tax1 q4tax2 q4tax3 q4tax4  q4gcn1 q4gcn2 q4gcn3 q4gcn4 q4gdp1 q4gdp2 q4gdp3 q4gdp4
end(system)
estimate(print,noftest) / resids(1)
compute nobs1 = %nobs
set rx = resids(3)
if %label([series]1)=='GCN'
 {; set rg = resids(1); set rt = resids(2); }
else if %label([series]1)=='TAX'
 {; set rg = resids(2); set rt = resids(1); }
end if

statistics rt
statistics rg
statistics rx


compute [label] covmatrix= 'v'+%label([series]1)+'.src'; source &covmatrix
compute shockt = (1+b2*a1*c2)/(1-a1*c1)
compute shockg = b2
compute shockx = c1*shockt + c2*shockg

display 'shockt' shockt 'shockt_t' shockt_t
display 'shockg' shockg 'shockg_t' shockg_t

compute [label] response = 'i'+type1+type2+type3+'np.src'; source &response
set resptaxl = resp1_to_1
set respgcnl = resp2_to_1
set respgdpl = resp3_to_1
set lowertaxl = lower1_to_1
set lowergcnl = lower2_to_1
set lowergdpl = lower3_to_1
set uppertaxl = upper1_to_1
set uppergcnl = upper2_to_1
set uppergdpl = upper3_to_1

compute [label] string3 = name+'.rat'
dedit(new) &string3
store $
resptaxl respgcnl respgdpl $
uppertaxl uppergcnl uppergdpl $
lowertaxl lowergcnl lowergdpl
save

end 1
**********************************************************************
**********************************************************************
**********************************************************************
**********************************************************************


*environment noecho


********************************************************************
compute [label] name = 'rra1'     ;* filename
compute [label] type1 = 'd'      ;* levels ('l') or diff ('d')
compute [label] type2 = 'a'      ;* all ('a') or one constant ('c')
compute [label] type3 = 'f'      ;* first shocked ('f') or second ('s')
*********************************************************************

cal 60 1 4
all 30 97:4


compute lags=4; compute nvar=3; compute nstep=20; compute ndraws=500
dec vector[series] resids(nvar)
*  defines the order of the variables in the VAR
eqv 1 to nvar; tax gcn  gdp


open data us.rat; data(format=rats,missing=-999) /

declare label string1 string2
compute [label] string1 = name+'.out'
compute [label] string2 = name+'.rgf'
open(append) output  &string1
open plot    &string2

dec vect[real] meanratio(nvar)
dofor  S = 1 to 2
set gigi = s{0}/gdp{0}
statistics(noprint) gigi
compute meanratio(s) = %mean
end dofor s
compute meanratio(nvar) = 1


dofor [series]s = 1 to nvar
set s = log(s{0}/(pop*pgdp))
set(scratch) s = s{0} - s{1}
statistics(noprint) [series]s
set aux1 = %if(%valid(s{0})==0,%na,t)
extremum(noprint) aux1
compute start1 = %minent
compute end1 = %maxent
*display start1 end1 %minent %maxent
*** taking differences of first diff from long weighted average *****
set(first=%mean) avers start1 end1 = .975*avers{1} + .025*s{0}
set(scratch) s  = s{0}-avers{0}
end dofor s

set commonsample = gcn*tax*gdp
statistics(noprint) etaxy
compute a1 = %mean
statistics(noprint) egcny
compute b1 = %mean


set trend = t
set trend2 = t**2

seasonal q1 / 4 1
seasonal q2 / 4 2
seasonal q3 / 4 3
seasonal q4 / 4 4

* allowing for quarter dependent coefficients

set q1tax0 = q1*tax
set q1tax1 = q1*tax{1}
set q1tax2 = q1*tax{2}
set q1tax3 = q1*tax{3}
set q1tax4 = q1*tax{4}

set q1gcn0 = q1*gcn
set q1gcn1 = q1*gcn{1}
set q1gcn2 = q1*gcn{2}
set q1gcn3 = q1*gcn{3}
set q1gcn4 = q1*gcn{4}

set q1gdp0 = q1*gdp
set q1gdp1 = q1*gdp{1}
set q1gdp2 = q1*gdp{2}
set q1gdp3 = q1*gdp{3}
set q1gdp4 = q1*gdp{4}


set q2tax0 = q2*tax
set q2tax1 = q2*tax{1}
set q2tax2 = q2*tax{2}
set q2tax3 = q2*tax{3}
set q2tax4 = q2*tax{4}

set q2gcn0 = q2*gcn
set q2gcn1 = q2*gcn{1}
set q2gcn2 = q2*gcn{2}
set q2gcn3 = q2*gcn{3}
set q2gcn4 = q2*gcn{4}

set q2gdp0 = q2*gdp
set q2gdp1 = q2*gdp{1}
set q2gdp2 = q2*gdp{2}
set q2gdp3 = q2*gdp{3}
set q2gdp4 = q2*gdp{4}


set q3tax0 = q3*tax
set q3tax1 = q3*tax{1}
set q3tax2 = q3*tax{2}
set q3tax3 = q3*tax{3}
set q3tax4 = q3*tax{4}

set q3gcn0 = q3*gcn
set q3gcn1 = q3*gcn{1}
set q3gcn2 = q3*gcn{2}
set q3gcn3 = q3*gcn{3}
set q3gcn4 = q3*gcn{4}

set q3gdp0 = q3*gdp
set q3gdp1 = q3*gdp{1}
set q3gdp2 = q3*gdp{2}
set q3gdp3 = q3*gdp{3}
set q3gdp4 = q3*gdp{4}


set q4tax0 = q4*tax
set q4tax1 = q4*tax{1}
set q4tax2 = q4*tax{2}
set q4tax3 = q4*tax{3}
set q4tax4 = q4*tax{4}

set q4gcn0 = q4*gcn
set q4gcn1 = q4*gcn{1}
set q4gcn2 = q4*gcn{2}
set q4gcn3 = q4*gcn{3}
set q4gcn4 = q4*gcn{4}

set q4gdp0 = q4*gdp
set q4gdp1 = q4*gdp{1}
set q4gdp2 = q4*gdp{2}
set q4gdp3 = q4*gdp{3}
set q4gdp4 = q4*gdp{4}

set q1tax = q1*tax
set q2tax = q2*tax
set q3tax = q3*tax
set q4tax = q4*tax

set q1gcn = q1*gcn
set q2gcn = q2*gcn
set q3gcn = q3*gcn
set q4gcn = q4*gcn

set q1gdp = q1*gdp
set q2gdp = q2*gdp
set q3gdp = q3*gdp
set q4gdp = q4*gdp


compute [label] dummies = 'dum'+type1+'1.src'; source &dummies


* quadratic trend

linreg tax
# tax{1 to 4} gcn{1 to 4} gdp{1 to 4}  $
  q2tax1 q2tax2 q2tax3 q2tax4  q2gcn1 q2gcn2 q2gcn3 q2gcn4 q2gdp1 q2gdp2 q2gdp3 q2gdp4   $
  q3tax1 q3tax2 q3tax3 q3tax4  q3gcn1 q3gcn2 q3gcn3 q3gcn4 q3gdp1 q3gdp2 q3gdp3 q3gdp4   $
  q4tax1 q4tax2 q4tax3 q4tax4  q4gcn1 q4gcn2 q4gcn3 q4gcn4 q4gdp1 q4gdp2 q4gdp3 q4gdp4   $
  vec1

exclude(noprint)
# q2tax1 q2tax2 q2tax3 q2tax4  q2gcn1 q2gcn2 q2gcn3 q2gcn4 q2gdp1 q2gdp2 q2gdp3 q2gdp4   $
  q3tax1 q3tax2 q3tax3 q3tax4  q3gcn1 q3gcn2 q3gcn3 q3gcn4 q3gdp1 q3gdp2 q3gdp3 q3gdp4   $
  q4tax1 q4tax2 q4tax3 q4tax4  q4gcn1 q4gcn2 q4gcn3 q4gcn4 q4gdp1 q4gdp2 q4gdp3 q4gdp4
display ' '
display 'p-value for quarter-dependent coefficients' #.### %signif
display ' '

linreg gcn
# tax{1 to 4} gcn{1 to 4} gdp{1 to 4}  $
  q2tax1 q2tax2 q2tax3 q2tax4  q2gcn1 q2gcn2 q2gcn3 q2gcn4 q2gdp1 q2gdp2 q2gdp3 q2gdp4   $
  q3tax1 q3tax2 q3tax3 q3tax4  q3gcn1 q3gcn2 q3gcn3 q3gcn4 q3gdp1 q3gdp2 q3gdp3 q3gdp4   $
  q4tax1 q4tax2 q4tax3 q4tax4  q4gcn1 q4gcn2 q4gcn3 q4gcn4 q4gdp1 q4gdp2 q4gdp3 q4gdp4   $
  vec1

exclude(noprint)
# q2tax1 q2tax2 q2tax3 q2tax4  q2gcn1 q2gcn2 q2gcn3 q2gcn4 q2gdp1 q2gdp2 q2gdp3 q2gdp4   $
  q3tax1 q3tax2 q3tax3 q3tax4  q3gcn1 q3gcn2 q3gcn3 q3gcn4 q3gdp1 q3gdp2 q3gdp3 q3gdp4   $
  q4tax1 q4tax2 q4tax3 q4tax4  q4gcn1 q4gcn2 q4gcn3 q4gcn4 q4gdp1 q4gdp2 q4gdp3 q4gdp4

display ' '
display 'p-value for quarter-dependent coefficients' #.### %signif
display ' '


linreg gdp
# tax{1 to 4} gcn{1 to 4} gdp{1 to 4}  $
  q2tax1 q2tax2 q2tax3 q2tax4  q2gcn1 q2gcn2 q2gcn3 q2gcn4 q2gdp1 q2gdp2 q2gdp3 q2gdp4   $
  q3tax1 q3tax2 q3tax3 q3tax4  q3gcn1 q3gcn2 q3gcn3 q3gcn4 q3gdp1 q3gdp2 q3gdp3 q3gdp4   $
  q4tax1 q4tax2 q4tax3 q4tax4  q4gcn1 q4gcn2 q4gcn3 q4gcn4 q4gdp1 q4gdp2 q4gdp3 q4gdp4   $
  vec1

exclude(noprint)
# q2tax1 q2tax2 q2tax3 q2tax4  q2gcn1 q2gcn2 q2gcn3 q2gcn4 q2gdp1 q2gdp2 q2gdp3 q2gdp4   $
  q3tax1 q3tax2 q3tax3 q3tax4  q3gcn1 q3gcn2 q3gcn3 q3gcn4 q3gdp1 q3gdp2 q3gdp3 q3gdp4   $
  q4tax1 q4tax2 q4tax3 q4tax4  q4gcn1 q4gcn2 q4gcn3 q4gcn4 q4gdp1 q4gdp2 q4gdp3 q4gdp4

display ' '
display 'p-value for quarter-dependent coefficients' #.### %signif
display ' '



system 1 to nvar; variables  1 to nvar; lags 1 to lags; kfset xxx;
det vec1 $
  q2tax1 q2tax2 q2tax3 q2tax4  q2gcn1 q2gcn2 q2gcn3 q2gcn4 q2gdp1 q2gdp2 q2gdp3 q2gdp4   $
  q3tax1 q3tax2 q3tax3 q3tax4  q3gcn1 q3gcn2 q3gcn3 q3gcn4 q3gdp1 q3gdp2 q3gdp3 q3gdp4   $
  q4tax1 q4tax2 q4tax3 q4tax4  q4gcn1 q4gcn2 q4gcn3 q4gcn4 q4gdp1 q4gdp2 q4gdp3 q4gdp4
end(system)
estimate(print,noftest) / resids(1)
compute nobs1 = %nobs
set rx = resids(3)
if %label([series]1)=='GCN'
 {; set rg = resids(1); set rt = resids(2); }
else if %label([series]1)=='TAX'
 {; set rg = resids(2); set rt = resids(1); }
end if

statistics rt
statistics rg
statistics rx


compute [label] covmatrix= 'v'+%label([series]1)+'.src'; source &covmatrix
compute shockt = (1+b2*a1*c2)/(1-a1*c1)
compute shockg = b2
compute shockx = c1*shockt + c2*shockg

display 'shockt' shockt 'shockt_t' shockt_t
display 'shockg' shockg 'shockg_t' shockg_t

compute [label] response = 'i'+type1+type2+type3+'np.src'; source &response

set resptaxd = resp1_to_1
set respgcnd = resp2_to_1
set respgdpd = resp3_to_1
set lowertaxd = lower1_to_1
set lowergcnd = lower2_to_1
set lowergdpd = lower3_to_1
set uppertaxd = upper1_to_1
set uppergcnd = upper2_to_1
set uppergdpd = upper3_to_1

compute [label] string3 = name+'.rat'
open data &string3
data(format=rats)


compute minlower = maxupper = 0.0
dofor [series]s = lowertaxl lowergcnl lowergdpl $
 lowertaxd lowergcnd lowergdpd
compute minlower = %min(minlower,%minvalue([series]s))
end dofor
dofor [series]s = uppertaxl uppergcnl uppergdpl $
 uppertaxd uppergcnd uppergdpd
compute maxupper = %max(maxupper,%maxvalue([series]s))
end dofor





spgraph(vfields=2,hfields=3)
smpl 1 nstep
     display(store=header2) 'resp. of spe, DT'
graph(nodates,header=header2,min=minlower,max=maxupper) 3  2 1
# respgcnl
# uppergcnl
# lowergcnl

     display(store=header1) 'resp. of tax, DT'
graph(nodates,header=header1,min=minlower,max=maxupper) 3  1 1
# resptaxl
# uppertaxl
# lowertaxl

     display(store=header3) 'resp. of gdp, DT'
graph(nodates,header=header3,min=minlower,max=maxupper) 3  3 1
# respgdpl
# uppergdpl
# lowergdpl


     display(store=header2) 'resp. of spe, ST'
graph(nodates,header=header2,min=minlower,max=maxupper) 3  2 2
# respgcnd
# uppergcnd
# lowergcnd

     display(store=header1) 'resp. of tax, ST'
graph(nodates,header=header1,min=minlower,max=maxupper) 3  1 2
# resptaxd
# uppertaxd
# lowertaxd

     display(store=header3) 'resp. of gdp, ST'
graph(nodates,header=header3,min=minlower,max=maxupper) 3  3 2
# respgdpd
# uppergdpd
# lowergdpd


spgraph(done)
close plot

